> ## Documentation Index
> Fetch the complete documentation index at: https://docs.dualship.run/llms.txt
> Use this file to discover all available pages before exploring further.

# List runtime logs

> Get runtime logs with granular filtering options



## OpenAPI

````yaml openapi.json get /api/v1/logs/runtime
openapi: 3.0.0
info:
  description: Dualship backend API for workflow automation and API management.
  title: Dualship API
  termsOfService: https://dualship.run/terms
  contact:
    name: Dualship Support
    url: https://dualship.run/support
    email: support@dualship.run
  version: '1.0'
servers:
  - url: https://api.dualship.run
security: []
paths:
  /api/v1/logs/runtime:
    get:
      tags:
        - logs
      summary: List runtime logs
      description: Get runtime logs with granular filtering options
      parameters:
        - description: Workspace ID
          name: X-Workspace-Id
          in: header
          required: true
          schema:
            type: string
        - description: Project ID (uses default if not specified)
          name: project_id
          in: query
          schema:
            type: string
        - description: Filter by flow ID
          name: flow_id
          in: query
          schema:
            type: string
        - description: Filter by flow slug
          name: flow_slug
          in: query
          schema:
            type: string
        - description: Filter by request ID
          name: request_id
          in: query
          schema:
            type: string
        - description: Filter by node ID
          name: node_id
          in: query
          schema:
            type: string
        - description: Filter by node type
          name: node_type
          in: query
          schema:
            type: string
        - description: Filter by log level (debug, info, warn, error)
          name: level
          in: query
          schema:
            type: string
        - description: Filter by multiple levels (comma-separated)
          name: levels
          in: query
          schema:
            type: string
        - description: Search in message (case-insensitive)
          name: message
          in: query
          schema:
            type: string
        - description: Filter logs after this time (RFC3339)
          name: start_time
          in: query
          schema:
            type: string
        - description: Filter logs before this time (RFC3339)
          name: end_time
          in: query
          schema:
            type: string
        - description: Sort by field (created_at, level, node_type, node_id)
          name: sort_by
          in: query
          schema:
            type: string
            default: created_at
        - description: Sort order (asc, desc)
          name: sort_order
          in: query
          schema:
            type: string
            default: desc
        - description: Limit results (max 1000)
          name: limit
          in: query
          schema:
            type: integer
            default: 100
        - description: Offset for pagination
          name: offset
          in: query
          schema:
            type: integer
            default: 0
      responses:
        '200':
          description: List of runtime logs with pagination
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/internal_api_handler.RuntimeLogsListResponse
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/internal_api_handler.BadRequestError'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/internal_api_handler.UnauthorizedError'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/internal_api_handler.InternalServerError'
      security:
        - BearerAuth: []
components:
  schemas:
    internal_api_handler.RuntimeLogsListResponse:
      type: object
      properties:
        limit:
          type: integer
        logs:
          type: array
          items:
            $ref: '#/components/schemas/internal_api_handler.RuntimeLogResponse'
        offset:
          type: integer
        total:
          type: integer
    internal_api_handler.BadRequestError:
      description: Bad request error
      type: object
      properties:
        code:
          type: string
          example: BAD_REQUEST
        error:
          type: string
          example: invalid request parameters
    internal_api_handler.UnauthorizedError:
      description: Unauthorized error
      type: object
      properties:
        code:
          type: string
          example: UNAUTHORIZED
        error:
          type: string
          example: unauthorized
    internal_api_handler.InternalServerError:
      description: Internal server error
      type: object
      properties:
        code:
          type: string
          example: INTERNAL_ERROR
        error:
          type: string
          example: internal server error
    internal_api_handler.RuntimeLogResponse:
      type: object
      properties:
        created_at:
          type: string
        data:
          type: object
          additionalProperties: {}
        flow_id:
          type: string
        flow_slug:
          type: string
        id:
          type: string
        level:
          type: string
        message:
          type: string
        node_id:
          type: string
        node_type:
          type: string
        request_id:
          type: string
        stack_trace:
          type: string
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: JWT Bearer token authentication

````